package pqrtree;

/**
 * A <code>Leaf</code> object is one-to one
 * correponding with the elements of the universe set.
 * It can store any Object as data.
 * 
 * @version 0.1
 * @author Bruno Dilly
 * @see pqrtree.Node
 */
public class Leaf extends Node {
	private Object data; // the data stored
	
	/**
	 * Creates a new leaf of the PQRTree, that stores an object, and 
	 * it is linked to it's ancestor.
	 * @param data
	 * @param ancestor The internal node from which the new node descend.
	 * @see Node#Node(PQRNode)
	 */
	public Leaf(Object data, PQRNode ancestor)
	{
		super(ancestor);
		this.data = data;
		leaf = true;
	}
	
	/**
	 * Gets data stored in the leaf when it was instaciated.
	 * @return Data stored.
	 */
	public Object getData() 
	{ 
		return data;
	}
}
