package pqrtreeapplet;

import java.awt.*;
import javax.swing.*;

/**
 * The applet class, that defines size and
 * creates the controller.
 * 
 * Based in the PQApplet class of Jon Harris' Graphical Implementation of 
 * PQ Tree Data Structure.
 * <a href="http://www.jharris.ca/portfolio/accode/PQTree.html">PQ Tree</a>
 * link.
 * 
 * @version 0.1
 * @author Bruno Dilly
 *
 */
public class PQRApplet extends JApplet
{
	private PQRController controller;
	private PQRApplet theApplet;
	static final long serialVersionUID = 2309; 
	
	/**
	 * Creates the controller and define size and other layout
	 * attributes.
	 * @throws Exception
	 */
	public PQRApplet() throws Exception
	{
		controller = new PQRController(30);
		GridBagLayout layout = new GridBagLayout(); 
		GridBagConstraints layoutCons = new GridBagConstraints(); 
		getContentPane().setLayout(layout);
		
		layoutCons.gridx = GridBagConstraints.RELATIVE; 
		layoutCons.gridy = GridBagConstraints.RELATIVE; 
		layoutCons.gridwidth = GridBagConstraints.REMAINDER;
		layoutCons.gridheight = GridBagConstraints.REMAINDER; 
		layoutCons.fill = GridBagConstraints.BOTH; 
		layoutCons.insets = new Insets(0, 0, 0, 0); 
		layoutCons.anchor = GridBagConstraints.NORTH; 
		layoutCons.weightx = 1.0; 
		layoutCons.weighty = 1.0; 
		layout.setConstraints(controller.getWindow(), layoutCons);
		
		getContentPane().add(controller.getWindow());
		
		setSize(PQRWindow.WIDTH+10,PQRWindow.HEIGHT+10);
		setVisible(true);
	}
	
	/**
	 * Creates the new applet.
	 */
	public void init()
	{
		try
		{
			theApplet = new PQRApplet();
		}
		catch (Exception e)
		{
			// do nothing
		}
	}
	
	/**
	 * Kills the controller threads and destroy the applet.
	 */
	public void destroy()
	{
		controller.destroy();
		theApplet = null;
	}

	/**
	 * Gets the applet.
	 * @return The new applet.
	 */
	public PQRApplet getApplet()
	{
		return theApplet;
	}
}
